<?xml version='1.0' encoding='UTF-8' ?>
<!--
@author felipe.cadena
@description Composite component para la información de la solicitud

Se debe usar con el manageBean ConsultaInformacionSolicitudMB el cual tiene los metodos para 
realizar las consultas necesarias para la vista.

Se debe llamar el metodo cerrar del MB ConsultaInformacionSolicitudMB en las paginas donde de use 
el componente para evitar conflictos con otros casos de uso.

-->

<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:f="http://java.sun.com/jsf/core"
      xmlns:p="http://primefaces.org/ui"
      xmlns:composite="http://java.sun.com/jsf/composite"
      xmlns:ui="http://java.sun.com/jsf/facelets">


    <composite:interface>

        <composite:attribute name="thisWVName" required="true" />
        <composite:attribute name="thisId" required="true" />

        <composite:attribute name="detallePredioWVName" required="true" 
                             shortDescription="WVname del componente que contiene los detalles del predio"/>
        <composite:attribute name="detallePredioId" required="true" 
                             shortDescription="id del componente que contiene los detalles del predio"/>

        <composite:attribute name="infoPredialWVName" required="true" 
                             shortDescription="WVname del componente que contiene la información predial del avalúo"/>
        <composite:attribute name="infoPredialId" required="true" 
                             shortDescription="id del componente que contiene la información predial del avalúo"/>

        <composite:attribute name="managedBean" required="false"
                             default="consultaInformacionSolicitud" />
        <composite:attribute name="mostrarDatosTramite" 
                             default="true"
                             shortDescription="decide si se muestra el tab con la info de tramite" />

        <composite:attribute name="mostrarDatosSolicitante" 
                             default="true"
                             shortDescription="decide si se muestra el tab con la info de los solicitantes" />

        <composite:attribute name="mostrarPredios" default="true"
                             shortDescription="decide si se muestra el tab con la info de los predios"/>

        <composite:attribute name="mostrarSecRadicados" 
                             default="true"
                             shortDescription="decide si se muestra el tab con la info de los Sec. Radicados" />

        <composite:attribute name="mostrarDocumentos" default="true" 
                             shortDescription="decide si se muestra el tab con la información de los documentos asociados a la solicitud" />

        <composite:attribute name="mostrarInfoPago" default="true" 
                             shortDescription="decide si se muestra el tab con la info del pago" />

    </composite:interface>

    <composite:implementation>

        <p:dialog widgetVar="#{cc.attrs.thisWVName}" id="infoSolicituDialogCC"
                  modal="true" dynamic="true" height="500" appendToBody="true"
                  width="950" minHeight="300" minWidth="750"
                  header="Información de la solicitud" closable="true" maximizable="false"
                  minimizable="false" resizable="false">

            <h:panelGrid id="infoSolicitudPG" width="100%">

                <p:tabView id="infoSolicitudTV" dynamic="true">

                    <p:tab title="Trámite solicitud"
                           rendered="#{cc.attrs.mostrarDatosTramite}">

                        <legend>
                            <h:outputText value="Información de la solicitud"
                                          styleClass="legendTitle" />
                        </legend>

                        <h:panelGrid columns="4" cellpadding="15" width="100%">
                            <h:outputLabel value="Número Solicitud: " styleClass="outputLabelStyle" />

                            <h:outputText styleClass="outputTextStyle"
                                          value="#{cc.attrs.managedBean.solicitud.numero}" />
                            <h:outputLabel value="Fecha de radicación: " styleClass="outputLabelStyle" />

                            <h:outputText styleClass="outputTextStyle"
                                          value="#{cc.attrs.managedBean.solicitud.fecha}">
                                <f:convertDateTime pattern="#{general.formatoFechaUsuario2}" />
                            </h:outputText>
                            <h:outputLabel value="Número Sec. Radicado: " styleClass="outputLabelStyle"
                                           rendered="#{cc.attrs.managedBean.filtroSecRadicado}"/>

                            <h:outputText styleClass="outputTextStyle"
                                          value="#{cc.attrs.managedBean.avaluo.secRadicado}"
                                          rendered="#{cc.attrs.managedBean.filtroSecRadicado}">
                                <f:convertDateTime pattern="#{general.formatoFechaUsuario2}" />
                            </h:outputText>

                        </h:panelGrid>

                        <p:separator />

                        <legend>
                            <h:outputText value="Información del tramite"
                                          styleClass="legendTitle" />
                        </legend>
                        <h:panelGrid width="100%">
                            <ui:include
                                src="/avaluos/ingresoSolicitud/diligenciarSolicitudInformacionTipoTramite.xhtml" />
                        </h:panelGrid>

                    </p:tab>

                    <p:tab title="Datos solicitantes"
                           rendered="#{cc.attrs.mostrarDatosSolicitante}">

                        <legend>
                            <h:outputText value="Datos solicitantes"
                                          styleClass="legendTitle" />
                        </legend>

                        <h:panelGrid width="100%">
                            <ui:include src="/avaluos/util/resumenSolicitante.xhtml">
                                <ui:param name="headerTablaSolicitanteParam"
                                          value="Lista de solicitantes" />
                                <ui:param name="datosSolicitanteWvParam"
                                          value="addSolicitanteDialogWV" />

                            </ui:include>
                        </h:panelGrid>
                    </p:tab>

                    <p:tab title="Predios asociados" 
                           rendered="#{cc.attrs.mostrarPredios}">

                        <legend>
                            <h:outputText value="Predios asociados"
                                          styleClass="legendTitle" />
                        </legend>

                        <h:form  id="infoPredios">
                            <p:spacer height="10" width="0" />
                            <p:dataTable id="tablaPredios" var="predio" widgetVar="dtAPAWV"
                                         value="#{cc.attrs.managedBean.listaPredios}" paginator="true"
                                         rows="10" rowKey="#{predio.id}" 
                                         emptyMessage="El trámite no tiene predios asociados"
                                         rowsPerPageTemplate="10"
                                         paginatorPosition="bottom">

                                <f:facet name="header">  
                                    Predios asociados al tramite
                                </f:facet>

                                <p:column headerText="Departamento">
                                    <h:outputText styleClass="outputTextStyle"
                                                  value="#{predio.departamento.nombre}" />
                                </p:column>

                                <p:column headerText="Municipio">
                                    <h:outputText styleClass="outputTextStyle"
                                                  value="#{predio.municipio.nombre}" />
                                </p:column>

                                <p:column headerText="Tipo avalúo predio">
                                    <h:outputText value="#{predio.tipoAvaluoPredio}"
                                                  styleClass="outputTextStyle" id="AvaluoPredioTipoAvaluoV-1">
                                        <f:converter converterId="converterCB" for="AvaluoPredioTipoAvaluoV-1" />
                                    </h:outputText>
                                </p:column>

                                <p:column headerText="Dirección">
                                    <h:outputText styleClass="outputTextStyle"
                                                  value="#{predio.direccion}" />
                                </p:column>

                                <p:column headerText="Numero predial">
                                    <p:commandLink id="downloadLink"
                                                   action="#{cc.attrs.managedBean.inicializarConsultaPredioMB}"
                                                   styleClass="commandLinkStyle" value="#{predio.numeroPredial}"
                                                   update=":#{cc.attrs.detallePredioId}:detallesPredioTV"
                                                   oncomplete="#{cc.attrs.detallePredioWVName}.show();statusDialog2.hide()"
                                                   onstart="statusDialog2.show()">
                                        <f:setPropertyActionListener value="#{predio.numeroPredial}"
                                                                     target="#{cc.attrs.managedBean.numeroPredio}"/>
                                    </p:commandLink>
                                </p:column>

                                <p:column headerText="Matricula inmobiliaria"
                                          rendered="false">
                                    <h:outputText styleClass="outputTextStyle"
                                                  value="#{predio.numeroRegistro}" />
                                </p:column>

                                <p:column headerText="Condición jurídica">
                                    <h:outputText styleClass="outputTextStyle"
                                                  value="#{predio.condicionJuridica}" />
                                </p:column>

                                <p:column headerText="Área Terreno"
                                          rendered="false">
                                    <h:outputText styleClass="outputTextStyle"
                                                  value="#{predio.areaTerreno}" />
                                </p:column>

                                <p:column headerText="Área construcción"
                                          rendered="false">
                                    <h:outputText styleClass="outputTextStyle"
                                                  value="#{predio.areaConstruccion}" />
                                </p:column>

                                <p:column headerText="Contacto">
                                    <h:outputText styleClass="outputTextStyle"
                                                  value="#{predio.contacto.nombreCompleto}" />
                                </p:column>

                            </p:dataTable>

                            <p:spacer height="10" width="0" />
                        </h:form>

                    </p:tab>

                    <p:tab title="Sec. Radicados"
                           rendered="#{cc.attrs.mostrarSecRadicados and !cc.attrs.managedBean.filtroSecRadicado}">

                        <legend>
                            <h:outputText value="Sec. Radicados"
                                          styleClass="legendTitle" />
                        </legend>

                        <h:form  id="infoSecRadicados">

                            <p:spacer height="10" width="0" />

                            <p:dataTable
                                value="#{cc.attrs.managedBean.listaAvaluos}"
                                var="avaluo" id="secRadicadosTable"
                                rowKey="#{avaluo.id}"
                                paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} 
                                {PreviousPageLink} {CurrentPageReport} {NextPageLink} {LastPageLink}"
                                rowsPerPageTemplate="5,10,15"
                                widgetVar="secRadicadosTableWV"
                                emptyMessage="La Solicitud no tiene sec_radicados"
                                paginator="true"
                                rows="5"
                                paginatorPosition="bottom">

                                <f:facet name="header">  
                                    Sec. Radicados de la solicitud
                                </f:facet>

                                <p:column>
                                    <f:facet name="header">
                                        <h:outputText value="Sec. Radicado" title="Sec. Radicado" />
                                    </f:facet>

                                    <p:commandLink id="secRadicadoLink"
                                                   styleClass="commandLinkStyle"
                                                   onstart="statusDialog2.show();"
                                                   oncomplete="statusDialog2.hide()"
                                                   update=":#{cc.attrs.thisId}:infoSolicitudTV"
                                                   value="#{avaluo.secRadicado}"
                                                   action="#{cc.attrs.managedBean.consultarSecRadicado}">
                                        <f:setPropertyActionListener value="#{avaluo.secRadicado}"
                                                                     target="#{cc.attrs.managedBean.numeroSecRadicado}"/>

                                    </p:commandLink>
                                </p:column>

                                <p:column>
                                    <f:facet name="header">
                                        <h:outputText value="Fecha" title="Fecha de aprobación" />
                                    </f:facet>
                                    <h:outputText value="#{avaluo.tramite.fechaRadicacion}">
                                        <f:convertDateTime pattern="#{general.formatoFechaUsuario2}"/>
                                    </h:outputText>
                                </p:column>

                                <p:column>
                                    <f:facet name="header">
                                        Información predial				
                                    </f:facet>
                                    <p:commandLink id="infoPredialLink"
                                                   styleClass="commandLinkStyle"
                                                   value="Información predial"
                                                   onstart="statusDialog2.show();"
                                                   oncomplete="#{cc.attrs.infoPredialWVName}.show();statusDialog2.hide();"
                                                   update=":#{cc.attrs.infoPredialId}"
                                                   action="#{consultaInformacionPredial.cargarInformacionPredial}">
                                        <f:setPropertyActionListener value="#{avaluo}"
                                                                     target="#{consultaInformacionPredial.avaluoSeleccionado}"/>
                                    </p:commandLink>

                                </p:column>

                            </p:dataTable>

                        </h:form>

                    </p:tab>

                    <p:tab title="Información de documentos"
                           rendered="#{cc.attrs.mostrarDocumentos}">

                        <legend>
                            <h:outputText value="Documentos relacionados" styleClass="legendTitle" />
                        </legend>
                        <ui:include src="/avaluos/ingresoSolicitud/administracionDocumentacionAvaluoComercial.xhtml" />
                    </p:tab>
                    <p:tab title="Pago"
                           rendered="#{cc.attrs.mostrarInfoPago}">

                    </p:tab>

                </p:tabView>

            </h:panelGrid>


        </p:dialog>

    </composite:implementation>

</html>